#include <stdio.h>
#include <math.h>
#include <gl/glut.h>

#define MIN_X	-333
#define MAX_X	333
#define MIN_Y	-222
#define MAX_Y	222

#define MAX_N	100

typedef struct {
	double x, y, z;
} tocka_t;

tocka_t ociste, glediste;
tocka_t t[MAX_N];
int n;


void projekcija (tocka_t t, double *xp, double *yp)
{
	tocka_t g1, g2;
	double sina, cosa, sinb, cosb, h;
	tocka_t t1, t2, t3, t4, t5;

	// T1
	t1.x = t.x - ociste.x;
	t1.y = t.y - ociste.y;
	t1.z = t.z - ociste.z;
	g1.x = glediste.x - ociste.x;
	g1.y = glediste.y - ociste.y;
	g1.z = glediste.z - ociste.z;

	// T2: 
	sina = g1.y / sqrt (g1.x*g1.x + g1.y*g1.y);
	cosa = g1.x / sqrt (g1.x*g1.x + g1.y*g1.y);
	t2.x = t1.x * cosa + t1.y * sina;
	t2.y = - t1.x * sina + t1.y * cosa;
	t2.z = t1.z;
	g2.x = sqrt (g1.x*g1.x + g1.y*g1.y);
	g2.y = 0;
	g2.z = g1.z;

	// T3
	sinb = g2.x / sqrt (g2.x*g2.x + g2.z*g2.z);
	cosb = g2.z / sqrt (g2.x*g2.x + g2.z*g2.z);
	t3.x = t2.x * cosb - t2.z * sinb;
	t3.y = t2.y;
	t3.z = t2.x * sinb + t2.z * cosb;

	// T4
	t4.x = t3.y;
	t4.y = - t3.x;
	t4.z = t3.z;

	// T5
	t5.x = - t4.x; 
	t5.y = t4.y;
	t5.z = t4.z;

	// projekcija
	h = sqrt (pow (ociste.x-glediste.x, 2) + pow (ociste.y-glediste.y, 2) + pow (ociste.z-glediste.z, 2));
	*xp = (int) (t5.x * h / t5.z);
	*yp = (int) (t5.y * h / t5.z);
}


void citanjeDatoteke (char *datoteka)
{
	FILE *f;

	f = fopen (datoteka, "r");
	if (!f) {
		printf ("Datoteka %s ne postoji!?\n", datoteka);
		exit (1);
	}

	if (fscanf (f, "%lf %lf %lf", &(ociste.x), &(ociste.y), &(ociste.z)) != 3
	||  fscanf (f, "%lf %lf %lf", &(glediste.x), &(glediste.y), &(glediste.z)) != 3) {
		printf ("Molimo osigurajte da je datoteka %s u ispravnom formatu.\n", datoteka);
		exit (1);
	}
	for (n=0; fscanf (f, "%lf %lf %lf", &(t[n].x), &(t[n].y), &(t[n].z)) == 3; n++);
}


void obradaPrikaza (void)
{
	int i;
	double x, y;

	glClear (GL_COLOR_BUFFER_BIT);

	glColor3i (0, 0, 0);
	glBegin (GL_LINE_LOOP);
	for (i=0; i < n; i++) {
		projekcija (t[i], &x, &y);
		glVertex2f (x, y);
	}
	glEnd ();

	glutSwapBuffers ();
}


void main (int argc, char *argv[])
{
	char *datoteka = "ulaz.txt";

	if (argc == 2)
		datoteka = argv[1];
	citanjeDatoteke (datoteka);

	glutInit (&argc, argv);
	glutInitDisplayMode (GLUT_DOUBLE);
	glutInitWindowPosition (100,100);
	glutInitWindowSize (MAX_X-MIN_X+1, MAX_Y-MIN_Y+1);
	glutCreateWindow ("Laboratorijska vjezba 5");

	glOrtho (MIN_X, MAX_X, MIN_Y, MAX_Y, 0, 1); 
	glClearColor (1.0, 1.0, 1.0, 1.0);
	glColor3f (0.4, 0.4, 0.4);

	glutDisplayFunc (obradaPrikaza);
	glutMainLoop ();
}